'use strict';

const $moduleName = "@wider/registry/test.js";
const {
    describe_loaded,
    describe_published,
    register,
    merge,
    bundle,
    find
} = require( "." ).registry;

// ok
register( $moduleName, {
    $moduleName: $moduleName
}, "registryTester" );

// throw
console.log( "\nextend error expected" );
try {
    register( $moduleName );
} catch ( err ) {}

// test for $wider core
const $wider = require( "." );

console.log( "\ntesting merge" );
try {
    merge( $moduleName, [ {
        item: {
            value: 1,
            $moduleName: "item"
        },
        item2: 2
    } ], "mergedEntries" );
} catch ( err ) {
    console.error( err );
}

console.log( "\ntesting bundle - error expected for item2 as it is not a module object" );
try {
    bundle( [ {
            value: 1,
            $moduleName: "item"
        },
        2
    ], "anotherSection" );
} catch ( err ) {
    console.error( err );
}

// demo bundle for readMe
const something1 = {
    $moduleName: "something1"
};
const something2 = {
    $moduleName: "something2"
};
console.log( "\n README bundle demo" );
const sOOE = [ something1, something2 ];
bundle( sOOE, "sOOname" );

console.log( "\ndemo merge for readme first fails - no matching container" );

const newProps = {
    a: 1,
    b: 2,
    c: 3
};
merge( something1.$moduleName );


merge( something1.$moduleName, newProps );
console.log( "\ndemo merge for readme second works" );

// try a soft load
if ( global.$wider )
    process.nextTick( () => {
        console.log( "\n testing soft register - should throw an untrapped error as moduleName already loaded and appear after the documentation output in the source code following" );
        global.$wider.registry.register( $moduleName );
    } );

console.log("\ntest find()");
console.log(JSON.stringify( find("something1")));

console.log( "\nwider" );
console.log( $wider );

console.log( describe_loaded() );
console.log( describe_published() );

console.log( "\ntest complete" );